//
//   main.m
//   copymykey
//
//   Created by Richard Williamson on 1/24/13.
//   Copyright (c) 2013 R1CH4RD.net. All rights reserved.
//
//   By downloading this file you agree to the following
//   You may use this file for recompile purposes only
//   You may not alter or redistribute this file with out written consent of the original author
//   You may not use this code to make money
//   I freely gave this to you and you will give me credit if you use it
//


// Includes
#include <unistd.h>
#include <sys/types.h>
#include <pwd.h>
#include <assert.h>

NSString *getUserDir() {
     struct passwd *pw = getpwuid(getuid());
     assert(pw);
     return [NSString stringWithUTF8String:pw->pw_dir];
}

void usage(const char *name) {
     printf("copymykey version 0.1\n");
     printf("Written by: Richard Williamson <richard@r1ch4rd.net>\n");
     printf("usage: %s user@host [options -k local_key_file/path.pub -f remote_key_file/path/authorized_keys\r", name);
     printf("    OPTIONAL ARGUMENTS\n");
     printf("        -k path/to/key.pub\n");
     printf("        -f path/to/remote/authorized_keys\n");
     printf("        -h prints this menu\n");
     printf("        -v gets version info\n");
}

int main(int args, const char * argument[])
{
     
     @autoreleasepool {
          NSString *_file;
          NSString *_remoteFile;
          NSString *_serverString;
          // Create the managed object context
          // -k <path of key>
          // -f <path to put key>
          
          // default would be username@host;
          // just incase it doesn't get set we use the defaults.
          _file = [NSString stringWithFormat:@"%@/.ssh/id_rsa.pub", getUserDir()];
          _remoteFile = @"~/.ssh/authorized_keys";
          
          if (args >= 2) {
               NSString *tString = [NSString stringWithFormat:@"%s", argument[1]];
               if ([tString isEqualToString:@"-h"]) {
                    usage(argument[0]);
                    exit(EXIT_SUCCESS);
               }
               else if ([tString isEqualToString:@"help"]) {
                    usage(argument[0]);
                    exit(EXIT_SUCCESS);
               }
               else if ( [tString isEqualToString:@"-v"]) {
                    usage(argument[0]);
                    exit(EXIT_SUCCESS);
               } else {
                    _serverString = [NSString stringWithFormat: @"%s", argument[1]];
                    if (args == 2) {
                         printf("Using default file placement.\n");
                    }
                    else if (args > 6) {
                         usage(argument[0]);
                         exit(EXIT_FAILURE);
                    } else {
                         if (args >= 4) {
                              NSString *tArg = [NSString stringWithFormat:@"%s", argument[2]];
                              if ([tArg isEqualToString:@"-k"]) {
                                   _file = [NSString stringWithFormat: @"%s", argument[3]];
                              } else if ([tArg isEqualToString:@"-f"]) {
                                   _remoteFile = [NSString stringWithFormat: @"%s", argument[3]];
                              } else {
                                   usage(argument[0]);
                                   exit(EXIT_FAILURE);
                              }
                              
                         } else if (args == 3 && args == 5) {
                              usage(argument[0]);
                              exit(EXIT_FAILURE);
                         }
                         if (args == 6) {
                              NSString *tArg2 = [NSString stringWithFormat:@"%s", argument[4]];
                              if ([tArg2 isEqualToString:@"-k"]) {
                                   _file = [NSString stringWithFormat: @"%s", argument[5]];
                              } else if ([tArg2 isEqualToString:@"-f"]) {
                                   _remoteFile = [NSString stringWithFormat: @"%s", argument[5]];
                              } else {
                                   usage(argument[0]);
                                   exit(EXIT_FAILURE);
                              }
                         }
                    }
                    
                    // at ~/.ssh/id_rsa.pub | ssh richardw@r1ch4rd.net "cat >> ~/.ssh/authorized_keys"
                    NSString *command = [NSString stringWithFormat: @"cat %@ | ssh %@ 'cat >> %@'", _file, _serverString, _remoteFile];
                    
                    printf(" local file: %s\n", [_file cStringUsingEncoding:NSASCIIStringEncoding]);
                    printf("remote file: %s\n", [_remoteFile cStringUsingEncoding:NSASCIIStringEncoding]);
                    printf("attempting to copy key\n");
                    system([command cStringUsingEncoding:NSASCIIStringEncoding]);
                    printf("testing key in 5 seconds\n");
                    sleep(5);
                    command = [NSString stringWithFormat:@"ssh %@", _serverString];
                    system([command cStringUsingEncoding:NSASCIIStringEncoding]);
               }
          } else {
               usage(argument[0]);
               exit(EXIT_FAILURE);
          }
     }
     return 0;
}